import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:pc_plugins/controllers/gallery/temp_config.dart';
import 'package:pc_plugins/controllers/pageInfo_controller.dart';

import '../../custom_exception.dart';
import '../algolia_filter_providers.dart';
import '../repository_template.dart';

// final csProvider= StateNotifierProvider<tController,AsyncValue<List<Case>>>(
//         (ref){final user=ref.watch(authControllerProvider);
//     return csController(ref.read,user?.uid);
//     });

class tController<T> extends StateNotifier<AsyncValue<searchData<T>>> {
  final Reader reader;
  final String? uid;
  final repo_tempConfig<T> config;
  // String pageid;
  // int defaultPSize;

  tController(this.reader,this.uid,{required this.config}) :super(const AsyncValue.loading()){
    // if(initialLoad)search(null,showNoResult: false);
  }

  // pageInd get searchConfig=>reader(pageIndexPvd(config.pageid));

  Future<void> initialLoad({int? lmt})async{
    if(state.asData==null)await search(null,lmt:lmt,showNoResult: false);
  }

  void setDialog(String s){
    if(config.dialogC!=null) {
      reader(config.dialogC!.state).update((state) => s);}
  }
  void setExDialog(CustomException e){
    if(config.exDialogC!=null) {
      reader(config.exDialogC!.state).update((state) => e);}
  }

  Future<void> loadafter({int? lmt}) async{
    if(state.value?.canNext==true) {
      return search(state.value?.query,page: state.value!.page+1,
          lmt: lmt??config.defaultPSize);
    } else {
      setDialog("this is the last page :|");}
  }

  Future<void> search(String? s,{int? lmt,int page=0,bool showNoResult=true}) async{
    if(reader(searchingPvd(config.pageid))||uid==null)return;

    if(config.onSearchChange!=null)config.onSearchChange!(reader);
    reader(searchingPvd(config.pageid).state).state=true;

    final filters=reader(algoFiltersPvd(config.pageid)).values.map((e) => e.function).toList();

    try {
      final agdata=config.customSearchFunc!=null?
      await config.customSearchFunc!(s,reader, page: page,hperp: lmt??config.defaultPSize,
              containID: uid,filters: filters):
      await reader(config.dataSrcPvd).searchT_algo(
          s, page: page,hperp: lmt??config.defaultPSize,
          containID: uid,filters: filters);
      if(agdata.pageInfo["nbHits"]==0&&showNoResult){
        setDialog("no result found");
      }

      state = AsyncValue.data(agdata);
    } on CustomException catch (e, st) {
      setExDialog(e);
    }
    reader(searchingPvd(config.pageid).state).state=false;
  }

  Future<void> getSuggest(T c) async{
    if(reader(searchingPvd(config.pageid))||uid==null)return;

    if(config.onSearchClick!=null)config.onSearchClick!(reader);
    reader(searchingPvd(config.pageid).state).state=true;
    try {
      // gcs = await reader(fsRepoProvider).getGCs(uid,lmt);
      final data=await reader(config.dataSrcPvd).getbyId(config.getId(c));
      state = AsyncValue.data(searchData.single(data));

    } on CustomException catch (e, st) {
      setExDialog(e);
    }
    reader(searchingPvd(config.pageid).state).state=false;
  }

  Future<void> loadb4({int? lmt}) async{
    if(state.value?.canPre==true) {
      return search(state.value?.query,
          page: state.value!.page-1,
          lmt: lmt??config.defaultPSize);
    } else {
      setDialog("this is the first page :|");}
  }

  updatePvds(T c)async{
    if(state.value==null)return;

    final i=state.value!.data.indexWhere((e) => config.getId(e)==config.getId(c));
    if(i!=-1){return state=AsyncValue.data(state.value!.copyWith(data: state.value!.data..[i]=c));}

    var filters=Map.of(reader(algoFiltersPvd(config.pageid)));
    if(config.scopeFilters!=null){
      filters.removeWhere((k, v) => config.scopeFilters!.contains(k));}

    if(state.value!.data.length<state.value!.hitsPerPage&&
        state.value!.query.isEmpty&&state.value!.params.isEmpty){
      state=AsyncValue.data(state.value!.add(c));}
  }

  Future<bool> updateT(T c)async{
    try{
      await reader(config.dataSrcPvd).edit(c);
      updatePvds(c);
      return true;
    }on CustomException catch(e,st){
      setExDialog(e);
      return false;
    }
  }

  Future<bool> addT(T c)async{
    try{
      final t=await reader(config.dataSrcPvd).add(c);

      updatePvds(t);
      return true;
    }on CustomException catch(e,st){
      setExDialog(e);
      return false;
    }
  }

  Future<void> set2read(T c)async{
    try{
      if(uid==null||config.isUnread==null||!config.isUnread!(c,uid!))return;
      final nw=await reader(config.dataSrcPvd).read(c,uid!);
      updatePvds(nw);
    }on CustomException catch(e,st){
      setExDialog(e);
    }
  }
}
