import 'package:algolia/algolia.dart';

class searchData<T>{
  final List<T> data;
  final Map<String,dynamic> pageInfo;
  searchData({required this.data,this.pageInfo=const <String,dynamic>{}});

  searchData.single(T data):data=[data],
        pageInfo={"length":1,"nbHits":1,"nbPages":1,"page":0};

  String get params => pageInfo['params'];
  String? get queryID => pageInfo['queryID'];
  String get query => pageInfo['query'];

  int get hitsPerPage => pageInfo['hitsPerPage'] ?? 0;
  int get length => pageInfo['length'] ?? 0;
  int get nbHits => pageInfo['nbHits'] ?? 0;
  int get nbPages => pageInfo['nbPages'] ?? 0;
  int get offset => pageInfo['offset'] ?? 0;
  int get page => pageInfo['page'] ?? 0;

  Map<String, dynamic> get facets => pageInfo['facets'] ?? {};
  Map<String, dynamic> get facetsStats => pageInfo['facets_stats'] ?? {};

  bool get exhaustiveNbHits => pageInfo['exhaustiveNbHits'];
  int get processingTimeMS => pageInfo['processingTimeMS'] ?? 0;

  searchData<T> copyWith({List<T>? data,Map<String,dynamic>? pageInfo}){
    return searchData(data: data??this.data,pageInfo: pageInfo??this.pageInfo);
  }
  searchData<T> add(T data){
    final pginfo=pageInfo..["nbHits"]=(nbHits+1);
    if(pageInfo['length']!=null)pginfo['length']=length+1;
    return searchData(data: this.data..add(data),pageInfo: pginfo);
  }

  bool get canPre=>page!=0;
  bool get canNext=>page!=nbPages-1;
}
abstract class baseTRepo<T>{
  Future<searchData<T>>searchT_algo(String? qr,
      {List<String> attributes=const ["objectId"],
        List<AlgoliaQuery Function(AlgoliaQuery)>?filters ,List<String>? strFilters,
        int page=0,int hperp=10,String? containID});

  Future<AlgoliaQuerySnapshot>searchTSnaps_algo(String? qr,
      {List<String> attributes=const ["objectId"],
        List<AlgoliaQuery Function(AlgoliaQuery)>?filters ,
        int page=0,int hperp=10,String? containID});

  Future<List<T>> snaps_2_Tdata(List<AlgoliaObjectSnapshot> snaps);

  Future<T> getbyId(String id);
  Future<T> read(T c,String uid);
  Future<T> add(T c);
  Future<void> edit(T c);
  Future<void> deletebyId(String id);
}